/*
 *  ZeX/OS
 *  Copyright (C) 2007  Tomas 'ZeXx86' Jedrzejek (zexx86@zexos.org)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <libx/base.h>
#include <libx/object.h>
#include <libx/image.h>
#include <libx/cursor.h>
#include "cursor.h"
#include "config.h"

wmcursor *cursor;

const unsigned char cursor_bitmap [] = {
	0x3f,0x3f,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x3f,0x3f,0x3f,0x3f,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0x3f,0x3f,0x3f,0xff,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0x3f,0xff,0xff,0xff,0x3f,0x00,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f
};

unsigned cursor_setpos (unsigned x, unsigned y)
{
	if (!cursor)
		return 0;
	
	cursor->x = x;
	cursor->y = y;

	return 1;
}

unsigned cursor_getpos (unsigned x, unsigned y)
{
	if (!cursor)
		return 0;
	
	x = cursor->x;
	y = cursor->y;

	return 1;
}

unsigned cursor_setstate (unsigned state)
{
	if (!cursor)
		return 0;
	
	cursor->state |= state;

	return 1;
}

unsigned char cursor_getstate ()
{
	if (!cursor)
		return 0;
	
	return cursor->state;
}

unsigned cursor_draw ()
{
	if (!cursor)
		return 0;

	if (!cursor->active)
		return 2;

	int ret = xcursor_update ();

	xcursor_getpos (&cursor->x, &cursor->y);

	switch (ret) {
		case 0:
			cursor->state = 0;
			break;
		case XCURSOR_STATE_RBUTTON:
			cursor->state = XCURSOR_STATE_RBUTTON;
			break;
		case XCURSOR_STATE_LBUTTON:
			cursor->state = XCURSOR_STATE_LBUTTON;
			break;
		case XCURSOR_STATE_BBUTTON:
			cursor->state = XCURSOR_STATE_BBUTTON;
			break;
	}


	//xpixel (cursor->x, cursor->y, 55);
	//ximage_draw (cursor_img, cursor->x, cursor->y, 0);
	unsigned i = 0;
	unsigned j = 0;
	unsigned k = 0;
	for (i = 0; i < 15*15; i ++) {
		if (k >= 15) {
			j ++;
			k = 0;
		}

		if (cursor_bitmap[i] != 0xff)
			xpixel (cursor->x+k, cursor->y+j, cursor_bitmap[i]*256);

		k ++;
	}
	//ximage_draw_spec (cursor_img, cursor->x, cursor->y, 24, 24, 0, 0, 0);

	return 1;
}

unsigned init_cursor ()
{
	/*cursor_img = ximage_open ("rocket");

	if (!cursor_img)
		return 0;*/

	cursor = (wmcursor *) malloc (sizeof (wmcursor));

	if (!cursor)
		return 0;

	cursor->x = 0;
	cursor->y = 0;
	cursor->active = 1;
	cursor->state = 0;
	cursor->action = 0;

	switch (cfg->mouse) {
		case 0:
			xcursor_settype (XCURSOR_MOUSE_KB);
			break;
		case 1:
			xcursor_settype (XCURSOR_MOUSE_SERIAL);
			break;
		case 2:
			xcursor_settype (XCURSOR_MOUSE_PS2);
			break;
		case 3:
			xcursor_settype (XCURSOR_MOUSE_USB);
			break;
	}

	int ret = xcursor_init ();

	if (!ret)
		return 0;

	return 1;
}
